
(function () {
    var callbackSet = {}
    window.InteractorProxy = {
        callbackHandler: callbackHandler,
        registerHandler: registerHandler,
        version: 3
    };

    function callbackHandler(data) {
        var callback = callbackSet[data.name];
        callback(data.params);
        delete callbackSet[data.name]
    }

    function registerHandler(appinfo) {
        InteractorProxy.app = appinfo
        var interactorReadyEvent = document.createEvent("Events");
        interactorReadyEvent.initEvent("onInteractorReady");
        interactorReadyEvent.InteractorProxy = InteractorProxy;
        document.dispatchEvent(interactorReadyEvent);
    }

    InteractorProxy.showMessageToast = function(message){
        var request = {"message": message}
        dispatchMethodName("showMessageToast")(JSON.stringify(request))
    }

    /**
     * {id: 111, nick: "tom"}
     */
    InteractorProxy.getUserInfo = function(){
        var info = dispatchMethodName("userInfo")()
        return JSON.parse(info)
    }

    InteractorProxy.postUrl = function(url, params, auth, fn){
        if(arguments.length == 4){
            var fnName = pushCallback(fn)
            dispatchMethodName("postUrl")(url, params, auth, fnName)
        } else if(arguments.length == 3){
            dispatchMethodName("postUrl")(url, params, auth)
        }
    }

    InteractorProxy.getUrl = function(url, auth, fn){
        if(arguments.length == 3){
            var fnName = pushCallback(fn)
            dispatchMethodName("getUrl")(url, auth, fnName)
        } else if(arguments.length == 2){
            dispatchMethodName("getUrl")(url, auth)
        }
    }

    InteractorProxy.startWechatPay = function(amount, channel, type){
        if(arguments.length == 3){
            dispatchMethodName("startWechatPay")(amount, channel, type)
        }
    }

    InteractorProxy.startAlipay = function(amount, channel, type){
        if(arguments.length == 3){
            dispatchMethodName("startAlipay")(amount, channel, type)
        }
    }

    InteractorProxy.login = function() {
        dispatchMethodName("login")()
    }

    function pushCallback(fn){
        var id = new Date().getTime() + "=="
        callbackSet[id] = fn
        return id
    }

    function dispatchMethodName(name){
        switch(name){
            case "showMessageToast": return AndroidProxy.showMessageToast.bind(AndroidProxy)
            case "getUrl": return AndroidProxy.get.bind(AndroidProxy)
            case "postUrl": return AndroidProxy.post.bind(AndroidProxy)
            case "userInfo": return AndroidProxy.requestUserInfo.bind(AndroidProxy)
            case "startWechatPay": return AndroidProxy.startWechatPay.bind(AndroidProxy)
            case "startAlipay": return AndroidProxy.startAlipay.bind(AndroidProxy)
            case "login": return AndroidProxy.login.bind(AndroidProxy)
            default: return function(){}
        }
    }
})();